
;**********************************************************************

	list      p=12c509            ; list directive to define processor
	#include <p12c509.inc>        ; processor specific variable definitions

	__CONFIG   _CP_OFF & _WDT_ON & _MCLRE_OFF & _IntRC_OSC


;***** VARIABLE DEFINITIONS

del0	equ	0x0f
del1	equ	0x10
cobit	equ	0x11
reg0	equ	0x14	;reg7...reg0
reg1	equ	0x15
reg2	equ	0x16
reg3	equ	0x17
reg4	equ	0x18
reg5	equ	0x19
reg6	equ	0x1a
reg7	equ	0x1b
coreg	equ	0x1c
cob	equ	0x1d
intfl	equ	0x1e

;**********************************************************************
		ORG     0x3FF             ; processor reset vector
; Internal RC calibration value is placed at location 0x3FF by Microchip
; as a movlw k, where the k is a literal value.

        ORG     0x000             ; coding begins here
        movwf   OSCCAL            ; update register with factory cal value

	movlw 0xca		;   .
	option			;wdt1:4
	btfsc STATUS,GPWUF	;   sleep, main(=1)
	goto main
first

	movlw 0x4a		;   .
	option			;
	sleep



main


	bcf STATUS,GPWUF
	movlw 0x32
	movwf reg7
	movlw 0x00
	movwf reg6
	movlw 0x00
	movwf reg5
	movlw 0x08
	movwf reg4
	movlw 0x29
	movwf reg3
	movlw 0x59
	movwf reg2
 	movlw 0x71
	movwf reg1
	movlw 0x01
	movwf reg0

	movlw 0xca		;   .
	option			;

com0

	btfsc	GPIO, 0		;  gp0  "0",
	goto	close		;(..  sleep  0  1?)
	;clrf 	TMR0		;   reset 

com1
	movlw 0xff
	movwf del1
d500
	btfsc GPIO,0
	goto pres
	decfsz del1, 1
	goto d500
	goto close

pres	call del30

; presence
	bcf GPIO, 0		;
	movlw 0xfe
	TRIS 6			;portb0=0, output

	call del60		;presence pulse 120us
	call del60

	movlw 0xff
	TRIS 6			;portb0, input

;  33H
c0	btfsc	GPIO, 0	;  RB0  "0"
	goto	c0
	call del30
	btfss GPIO, 0		;1
	goto close
	;nop
p0	btfss GPIO, 0		; 1
	goto p0

c1	btfsc	GPIO, 0	;  RB0  "0"
	goto	c1
	call del30
	btfss GPIO, 0		;1
	goto close
	;nop
p1	btfss GPIO, 0		; 1
	goto p1

c2	btfsc	GPIO, 0	;  RB0  "0"
	goto	c2
	call del30
	btfsc GPIO, 0		;0
	goto close
	;nop
p2	btfss GPIO, 0		; 1
	goto p2

c3	btfsc	GPIO, 0		;  RB0  "0"
	goto	c3
	call del30
	btfsc GPIO, 0		;0
	goto close
	;nop
p3	btfss GPIO, 0		; 1
	goto p3

c4	btfsc	GPIO, 0		;  RB0  "0"
	goto	c4
	call del30
	btfss GPIO, 0		;1
	goto close
	;nop
p4	btfss GPIO, 0		; 1
	goto p4

c5	btfsc	GPIO, 0		;  RB0  "0"
	goto	c5
	call del30
	btfss GPIO, 0		;1
	goto close
	;nop
p5	btfss GPIO, 0		; 1
	goto p5

c6	btfsc	GPIO, 0		;  RB0  "0"
	goto	c6
	call del30
	btfsc GPIO, 0		;0
	goto close
	;nop
p6	btfss GPIO, 0		; 1
	goto p6

c7	btfsc	GPIO, 0		;  RB0  "0"
	goto	c7
	call del30
	btfsc GPIO, 0		;0
	goto close
	;nop
p7	btfss GPIO, 0		; 1
	goto p7

qqqq
;
	;movlw .64
	;movwf cobit	;  

	movlw 0x08
	movwf coreg
	movlw 0x14
	movwf FSR
ask
	movlw 0x08
	movwf cob
ask0
	btfsc GPIO,0
	goto ask0
	;call rot
	rrf INDF,1
	btfss STATUS,C
	goto cout0
	goto cout1
cout0	call out0
	goto endout
cout1	call out1
endout
	decfsz cob,1
	;decfsz cobit, 1
	goto ask0

	incf FSR,1
	decfsz coreg,1
	goto ask
	goto close2

close	call bigdel
close2	call del60
	movlw 0x4a		;   .
	option
	sleep

out0	bcf GPIO, 0		; 0 = 30
	movlw 0xfe
	tris 6			;portb0=0, output

	call del30

	movlw 0xff
	tris 6			;portb0=0, input

	retlw 0

out1	call del30
	retlw 0

del30
	movlw 0x0a	
	movwf del1
d30
	decfsz del1, 1
	goto d30
	retlw 0

del60
	movlw 0x13
	movwf del1
d60
	decfsz del1, 1
	goto d60
	retlw 0

; ~10
bigdel
	movlw 0x08
	movwf del0

db1	movlw 0xff
	movwf del1

db2	decfsz del1, 1
	goto db2

	decfsz del0,1
	goto db1

	retlw 0




		END                     






